#SingleInstance force
#NoEnv
#Persistent
#include CLR.ahk

rm := new RollMouse()
return

class RollMouse {
	Rolling := 0
	MoveAmount := {x: 0, y: 0}
	
	__New(MouseDeltaDllPath := "MouseDelta.dll", MicroTimerDllPath := "MicroTimer.dll"){
		asm := CLR_LoadLibrary(MouseDeltaDllPath)
		md := asm.CreateInstance("MouseDelta")
		this.md := md
		
		asm := CLR_LoadLibrary(MicroTimerDllPath)
		mt := asm.CreateInstance("MicroTimer")
		this.mt := mt
		
		this.MoveTimer := mt.Create(this._DoMove.Bind(this), 2)
		
		md.SubscribeRelativeMove(this._MoveEvent.Bind(this))
		md.SubscribeRelativeMoveStop(this._StopEvent.Bind(this))
	}
	
	_MoveEvent(x, y, mouseId){
		if (this.Rolling){
			; Normal movement detected while we are rolling - stop the roll
			this.Rolling := 0
			this.MoveTimer.SetState(0)
		}
	}
	
	_StopEvent(tx, ty, lx, ly){
		; If we stop the mouse on the mat, inevitably the last movements will be low numbers
		; So if lastx or lasty is above a certain amount, we lifted while in motion
		if (abs(lx) > 3 || abs(ly) > 3){
			; Calculate the movement amount from the average of the total, rather than lastx or lasty...
			; ... so we get a more faithful representation of the general direction and magnitude of the gesture
			this.MoveAmount.x := (tx / 10)
			this.MoveAmount.y := (ty / 10)
			this.Rolling := 1
			this.MoveTimer.SetState(1)
		}
	}
	
	_DoMove(){
		DllCall("mouse_event", uint, 1, int, this.MoveAmount.x, int, this.MoveAmount.y, uint, 0, int, 0)
	}
}